/**
 */
package de.uni.due.swe.dataFlowDiagramPattern.provider;


import de.uni.due.swe.dataFlowDiagramPattern.Component;
import de.uni.due.swe.dataFlowDiagramPattern.DataFlowDiagramPatternFactory;
import de.uni.due.swe.dataFlowDiagramPattern.DataFlowDiagramPatternPackage;

import java.util.Collection;
import java.util.List;

import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.common.util.ResourceLocator;

import org.eclipse.emf.ecore.EStructuralFeature;

import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;
import org.eclipse.emf.edit.provider.ItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.ItemProviderAdapter;
import org.eclipse.emf.edit.provider.ViewerNotification;

/**
 * This is the item provider adapter for a {@link de.uni.due.swe.dataFlowDiagramPattern.Component} object.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class ComponentItemProvider 
	extends ItemProviderAdapter
	implements
		IEditingDomainItemProvider,
		IStructuredItemContentProvider,
		ITreeItemContentProvider,
		IItemLabelProvider,
		IItemPropertySource {
	/**
	 * This constructs an instance from a factory and a notifier.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ComponentItemProvider(AdapterFactory adapterFactory) {
		super(adapterFactory);
	}

	/**
	 * This returns the property descriptors for the adapted class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public List<IItemPropertyDescriptor> getPropertyDescriptors(Object object) {
		if (itemPropertyDescriptors == null) {
			super.getPropertyDescriptors(object);

			addNamePropertyDescriptor(object);
			addIsAssetPropertyDescriptor(object);
			addExternalDependencyPropertyDescriptor(object);
			addSecurityAssumptionsPropertyDescriptor(object);
			addSecurityNotesPropertyDescriptor(object);
			addElicitationReasoningPropertyDescriptor(object);
			addContainedByPrivilegeBoundaryPropertyDescriptor(object);
			addContainedVulnerabilitiesPropertyDescriptor(object);
			addPossibleAttackersPropertyDescriptor(object);
		}
		return itemPropertyDescriptors;
	}

	/**
	 * This adds a property descriptor for the Name feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addNamePropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_Component_name_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_Component_name_feature", "_UI_Component_type"),
				 DataFlowDiagramPatternPackage.Literals.COMPONENT__NAME,
				 true,
				 false,
				 false,
				 ItemPropertyDescriptor.GENERIC_VALUE_IMAGE,
				 null,
				 null));
	}

	/**
	 * This adds a property descriptor for the Is Asset feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addIsAssetPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_Component_isAsset_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_Component_isAsset_feature", "_UI_Component_type"),
				 DataFlowDiagramPatternPackage.Literals.COMPONENT__IS_ASSET,
				 true,
				 false,
				 false,
				 ItemPropertyDescriptor.BOOLEAN_VALUE_IMAGE,
				 null,
				 null));
	}

	/**
	 * This adds a property descriptor for the External Dependency feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addExternalDependencyPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_Component_externalDependency_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_Component_externalDependency_feature", "_UI_Component_type"),
				 DataFlowDiagramPatternPackage.Literals.COMPONENT__EXTERNAL_DEPENDENCY,
				 true,
				 false,
				 false,
				 ItemPropertyDescriptor.GENERIC_VALUE_IMAGE,
				 null,
				 null));
	}

	/**
	 * This adds a property descriptor for the Security Assumptions feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addSecurityAssumptionsPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_Component_securityAssumptions_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_Component_securityAssumptions_feature", "_UI_Component_type"),
				 DataFlowDiagramPatternPackage.Literals.COMPONENT__SECURITY_ASSUMPTIONS,
				 true,
				 false,
				 false,
				 ItemPropertyDescriptor.GENERIC_VALUE_IMAGE,
				 null,
				 null));
	}

	/**
	 * This adds a property descriptor for the Security Notes feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addSecurityNotesPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_Component_securityNotes_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_Component_securityNotes_feature", "_UI_Component_type"),
				 DataFlowDiagramPatternPackage.Literals.COMPONENT__SECURITY_NOTES,
				 true,
				 false,
				 false,
				 ItemPropertyDescriptor.GENERIC_VALUE_IMAGE,
				 null,
				 null));
	}

	/**
	 * This adds a property descriptor for the Elicitation Reasoning feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addElicitationReasoningPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_Component_elicitationReasoning_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_Component_elicitationReasoning_feature", "_UI_Component_type"),
				 DataFlowDiagramPatternPackage.Literals.COMPONENT__ELICITATION_REASONING,
				 true,
				 false,
				 false,
				 ItemPropertyDescriptor.GENERIC_VALUE_IMAGE,
				 null,
				 null));
	}

	/**
	 * This adds a property descriptor for the Contained By Privilege Boundary feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addContainedByPrivilegeBoundaryPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_Component_containedByPrivilegeBoundary_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_Component_containedByPrivilegeBoundary_feature", "_UI_Component_type"),
				 DataFlowDiagramPatternPackage.Literals.COMPONENT__CONTAINED_BY_PRIVILEGE_BOUNDARY,
				 true,
				 false,
				 true,
				 null,
				 null,
				 null));
	}

	/**
	 * This adds a property descriptor for the Contained Vulnerabilities feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addContainedVulnerabilitiesPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_Component_containedVulnerabilities_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_Component_containedVulnerabilities_feature", "_UI_Component_type"),
				 DataFlowDiagramPatternPackage.Literals.COMPONENT__CONTAINED_VULNERABILITIES,
				 true,
				 false,
				 true,
				 null,
				 null,
				 null));
	}

	/**
	 * This adds a property descriptor for the Possible Attackers feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addPossibleAttackersPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_Component_possibleAttackers_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_Component_possibleAttackers_feature", "_UI_Component_type"),
				 DataFlowDiagramPatternPackage.Literals.COMPONENT__POSSIBLE_ATTACKERS,
				 true,
				 false,
				 true,
				 null,
				 null,
				 null));
	}

	/**
	 * This specifies how to implement {@link #getChildren} and is used to deduce an appropriate feature for an
	 * {@link org.eclipse.emf.edit.command.AddCommand}, {@link org.eclipse.emf.edit.command.RemoveCommand} or
	 * {@link org.eclipse.emf.edit.command.MoveCommand} in {@link #createCommand}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Collection<? extends EStructuralFeature> getChildrenFeatures(Object object) {
		if (childrenFeatures == null) {
			super.getChildrenFeatures(object);
			childrenFeatures.add(DataFlowDiagramPatternPackage.Literals.COMPONENT__CONTAINED_DATA_FLOWS);
			childrenFeatures.add(DataFlowDiagramPatternPackage.Literals.COMPONENT__CONTAINED_VULNERABILITIES);
			childrenFeatures.add(DataFlowDiagramPatternPackage.Literals.COMPONENT__POSSIBLE_ATTACKERS);
			childrenFeatures.add(DataFlowDiagramPatternPackage.Literals.COMPONENT__CONTAINED_ASSETS);
		}
		return childrenFeatures;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EStructuralFeature getChildFeature(Object object, Object child) {
		// Check the type of the specified child object and return the proper feature to use for
		// adding (see {@link AddCommand}) it as a child.

		return super.getChildFeature(object, child);
	}

	/**
	 * This returns Component.gif.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object getImage(Object object) {
		return overlayImage(object, getResourceLocator().getImage("full/obj16/Component"));
	}

	/**
	 * This returns the label text for the adapted class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String getText(Object object) {
		String label = ((Component)object).getName();
		return label == null || label.length() == 0 ?
			getString("_UI_Component_type") :
			getString("_UI_Component_type") + " " + label;
	}
	

	/**
	 * This handles model notifications by calling {@link #updateChildren} to update any cached
	 * children and by creating a viewer notification, which it passes to {@link #fireNotifyChanged}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void notifyChanged(Notification notification) {
		updateChildren(notification);

		switch (notification.getFeatureID(Component.class)) {
			case DataFlowDiagramPatternPackage.COMPONENT__NAME:
			case DataFlowDiagramPatternPackage.COMPONENT__IS_ASSET:
			case DataFlowDiagramPatternPackage.COMPONENT__EXTERNAL_DEPENDENCY:
			case DataFlowDiagramPatternPackage.COMPONENT__SECURITY_ASSUMPTIONS:
			case DataFlowDiagramPatternPackage.COMPONENT__SECURITY_NOTES:
			case DataFlowDiagramPatternPackage.COMPONENT__ELICITATION_REASONING:
				fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), false, true));
				return;
			case DataFlowDiagramPatternPackage.COMPONENT__CONTAINED_DATA_FLOWS:
			case DataFlowDiagramPatternPackage.COMPONENT__CONTAINED_VULNERABILITIES:
			case DataFlowDiagramPatternPackage.COMPONENT__POSSIBLE_ATTACKERS:
			case DataFlowDiagramPatternPackage.COMPONENT__CONTAINED_ASSETS:
				fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), true, false));
				return;
		}
		super.notifyChanged(notification);
	}

	/**
	 * This adds {@link org.eclipse.emf.edit.command.CommandParameter}s describing the children
	 * that can be created under this object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected void collectNewChildDescriptors(Collection<Object> newChildDescriptors, Object object) {
		super.collectNewChildDescriptors(newChildDescriptors, object);

		newChildDescriptors.add
			(createChildParameter
				(DataFlowDiagramPatternPackage.Literals.COMPONENT__CONTAINED_DATA_FLOWS,
				 DataFlowDiagramPatternFactory.eINSTANCE.createDataFlow()));

		newChildDescriptors.add
			(createChildParameter
				(DataFlowDiagramPatternPackage.Literals.COMPONENT__CONTAINED_VULNERABILITIES,
				 DataFlowDiagramPatternFactory.eINSTANCE.createVulnerability()));

		newChildDescriptors.add
			(createChildParameter
				(DataFlowDiagramPatternPackage.Literals.COMPONENT__POSSIBLE_ATTACKERS,
				 DataFlowDiagramPatternFactory.eINSTANCE.createAttacker()));

		newChildDescriptors.add
			(createChildParameter
				(DataFlowDiagramPatternPackage.Literals.COMPONENT__CONTAINED_ASSETS,
				 DataFlowDiagramPatternFactory.eINSTANCE.createContainedAsset()));
	}

	/**
	 * Return the resource locator for this item provider's resources.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public ResourceLocator getResourceLocator() {
		return DataFlowDiagramPatternEditPlugin.INSTANCE;
	}

}
