/**
 */
package de.uni.due.swe.dataFlowDiagramPattern.impl;

import de.uni.due.swe.dataFlowDiagramPattern.Attacker;
import de.uni.due.swe.dataFlowDiagramPattern.Component;
import de.uni.due.swe.dataFlowDiagramPattern.ContainedAsset;
import de.uni.due.swe.dataFlowDiagramPattern.DataFlow;
import de.uni.due.swe.dataFlowDiagramPattern.DataFlowDiagramPatternPackage;
import de.uni.due.swe.dataFlowDiagramPattern.PrivilegeBoundary;
import de.uni.due.swe.dataFlowDiagramPattern.Vulnerability;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.MinimalEObjectImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.EObjectContainmentWithInverseEList;
import org.eclipse.emf.ecore.util.EObjectWithInverseResolvingEList;
import org.eclipse.emf.ecore.util.InternalEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Component</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link de.uni.due.swe.dataFlowDiagramPattern.impl.ComponentImpl#getName <em>Name</em>}</li>
 *   <li>{@link de.uni.due.swe.dataFlowDiagramPattern.impl.ComponentImpl#getContainedDataFlows <em>Contained Data Flows</em>}</li>
 *   <li>{@link de.uni.due.swe.dataFlowDiagramPattern.impl.ComponentImpl#isIsAsset <em>Is Asset</em>}</li>
 *   <li>{@link de.uni.due.swe.dataFlowDiagramPattern.impl.ComponentImpl#getExternalDependency <em>External Dependency</em>}</li>
 *   <li>{@link de.uni.due.swe.dataFlowDiagramPattern.impl.ComponentImpl#getSecurityAssumptions <em>Security Assumptions</em>}</li>
 *   <li>{@link de.uni.due.swe.dataFlowDiagramPattern.impl.ComponentImpl#getSecurityNotes <em>Security Notes</em>}</li>
 *   <li>{@link de.uni.due.swe.dataFlowDiagramPattern.impl.ComponentImpl#getElicitationReasoning <em>Elicitation Reasoning</em>}</li>
 *   <li>{@link de.uni.due.swe.dataFlowDiagramPattern.impl.ComponentImpl#getContainedByPrivilegeBoundary <em>Contained By Privilege Boundary</em>}</li>
 *   <li>{@link de.uni.due.swe.dataFlowDiagramPattern.impl.ComponentImpl#getContainedVulnerabilities <em>Contained Vulnerabilities</em>}</li>
 *   <li>{@link de.uni.due.swe.dataFlowDiagramPattern.impl.ComponentImpl#getPossibleAttackers <em>Possible Attackers</em>}</li>
 *   <li>{@link de.uni.due.swe.dataFlowDiagramPattern.impl.ComponentImpl#getContainedAssets <em>Contained Assets</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public abstract class ComponentImpl extends MinimalEObjectImpl.Container implements Component {
	/**
	 * The default value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected static final String NAME_EDEFAULT = "";

	/**
	 * The cached value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected String name = NAME_EDEFAULT;

	/**
	 * The cached value of the '{@link #getContainedDataFlows() <em>Contained Data Flows</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getContainedDataFlows()
	 * @generated
	 * @ordered
	 */
	protected EList<DataFlow> containedDataFlows;

	/**
	 * The default value of the '{@link #isIsAsset() <em>Is Asset</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isIsAsset()
	 * @generated
	 * @ordered
	 */
	protected static final boolean IS_ASSET_EDEFAULT = true;

	/**
	 * The cached value of the '{@link #isIsAsset() <em>Is Asset</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isIsAsset()
	 * @generated
	 * @ordered
	 */
	protected boolean isAsset = IS_ASSET_EDEFAULT;

	/**
	 * The default value of the '{@link #getExternalDependency() <em>External Dependency</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getExternalDependency()
	 * @generated
	 * @ordered
	 */
	protected static final String EXTERNAL_DEPENDENCY_EDEFAULT = "";

	/**
	 * The cached value of the '{@link #getExternalDependency() <em>External Dependency</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getExternalDependency()
	 * @generated
	 * @ordered
	 */
	protected String externalDependency = EXTERNAL_DEPENDENCY_EDEFAULT;

	/**
	 * The default value of the '{@link #getSecurityAssumptions() <em>Security Assumptions</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getSecurityAssumptions()
	 * @generated
	 * @ordered
	 */
	protected static final String SECURITY_ASSUMPTIONS_EDEFAULT = "";

	/**
	 * The cached value of the '{@link #getSecurityAssumptions() <em>Security Assumptions</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getSecurityAssumptions()
	 * @generated
	 * @ordered
	 */
	protected String securityAssumptions = SECURITY_ASSUMPTIONS_EDEFAULT;

	/**
	 * The default value of the '{@link #getSecurityNotes() <em>Security Notes</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getSecurityNotes()
	 * @generated
	 * @ordered
	 */
	protected static final String SECURITY_NOTES_EDEFAULT = "";

	/**
	 * The cached value of the '{@link #getSecurityNotes() <em>Security Notes</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getSecurityNotes()
	 * @generated
	 * @ordered
	 */
	protected String securityNotes = SECURITY_NOTES_EDEFAULT;

	/**
	 * The default value of the '{@link #getElicitationReasoning() <em>Elicitation Reasoning</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getElicitationReasoning()
	 * @generated
	 * @ordered
	 */
	protected static final String ELICITATION_REASONING_EDEFAULT = "";

	/**
	 * The cached value of the '{@link #getElicitationReasoning() <em>Elicitation Reasoning</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getElicitationReasoning()
	 * @generated
	 * @ordered
	 */
	protected String elicitationReasoning = ELICITATION_REASONING_EDEFAULT;

	/**
	 * The cached value of the '{@link #getContainedByPrivilegeBoundary() <em>Contained By Privilege Boundary</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getContainedByPrivilegeBoundary()
	 * @generated
	 * @ordered
	 */
	protected EList<PrivilegeBoundary> containedByPrivilegeBoundary;

	/**
	 * The cached value of the '{@link #getContainedVulnerabilities() <em>Contained Vulnerabilities</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getContainedVulnerabilities()
	 * @generated
	 * @ordered
	 */
	protected EList<Vulnerability> containedVulnerabilities;

	/**
	 * The cached value of the '{@link #getPossibleAttackers() <em>Possible Attackers</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getPossibleAttackers()
	 * @generated
	 * @ordered
	 */
	protected EList<Attacker> possibleAttackers;

	/**
	 * The cached value of the '{@link #getContainedAssets() <em>Contained Assets</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getContainedAssets()
	 * @generated
	 * @ordered
	 */
	protected EList<ContainedAsset> containedAssets;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ComponentImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return DataFlowDiagramPatternPackage.Literals.COMPONENT;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getName() {
		return name;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setName(String newName) {
		String oldName = name;
		name = newName;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, DataFlowDiagramPatternPackage.COMPONENT__NAME, oldName, name));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<DataFlow> getContainedDataFlows() {
		if (containedDataFlows == null) {
			containedDataFlows = new EObjectContainmentWithInverseEList<DataFlow>(DataFlow.class, this, DataFlowDiagramPatternPackage.COMPONENT__CONTAINED_DATA_FLOWS, DataFlowDiagramPatternPackage.DATA_FLOW__SOURCE);
		}
		return containedDataFlows;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isIsAsset() {
		return isAsset;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setIsAsset(boolean newIsAsset) {
		boolean oldIsAsset = isAsset;
		isAsset = newIsAsset;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, DataFlowDiagramPatternPackage.COMPONENT__IS_ASSET, oldIsAsset, isAsset));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getExternalDependency() {
		return externalDependency;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setExternalDependency(String newExternalDependency) {
		String oldExternalDependency = externalDependency;
		externalDependency = newExternalDependency;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, DataFlowDiagramPatternPackage.COMPONENT__EXTERNAL_DEPENDENCY, oldExternalDependency, externalDependency));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getSecurityAssumptions() {
		return securityAssumptions;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setSecurityAssumptions(String newSecurityAssumptions) {
		String oldSecurityAssumptions = securityAssumptions;
		securityAssumptions = newSecurityAssumptions;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, DataFlowDiagramPatternPackage.COMPONENT__SECURITY_ASSUMPTIONS, oldSecurityAssumptions, securityAssumptions));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getSecurityNotes() {
		return securityNotes;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setSecurityNotes(String newSecurityNotes) {
		String oldSecurityNotes = securityNotes;
		securityNotes = newSecurityNotes;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, DataFlowDiagramPatternPackage.COMPONENT__SECURITY_NOTES, oldSecurityNotes, securityNotes));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getElicitationReasoning() {
		return elicitationReasoning;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setElicitationReasoning(String newElicitationReasoning) {
		String oldElicitationReasoning = elicitationReasoning;
		elicitationReasoning = newElicitationReasoning;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, DataFlowDiagramPatternPackage.COMPONENT__ELICITATION_REASONING, oldElicitationReasoning, elicitationReasoning));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<PrivilegeBoundary> getContainedByPrivilegeBoundary() {
		if (containedByPrivilegeBoundary == null) {
			containedByPrivilegeBoundary = new EObjectWithInverseResolvingEList.ManyInverse<PrivilegeBoundary>(PrivilegeBoundary.class, this, DataFlowDiagramPatternPackage.COMPONENT__CONTAINED_BY_PRIVILEGE_BOUNDARY, DataFlowDiagramPatternPackage.PRIVILEGE_BOUNDARY__COMPONETS_WITHIN);
		}
		return containedByPrivilegeBoundary;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Vulnerability> getContainedVulnerabilities() {
		if (containedVulnerabilities == null) {
			containedVulnerabilities = new EObjectContainmentEList<Vulnerability>(Vulnerability.class, this, DataFlowDiagramPatternPackage.COMPONENT__CONTAINED_VULNERABILITIES);
		}
		return containedVulnerabilities;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Attacker> getPossibleAttackers() {
		if (possibleAttackers == null) {
			possibleAttackers = new EObjectContainmentWithInverseEList<Attacker>(Attacker.class, this, DataFlowDiagramPatternPackage.COMPONENT__POSSIBLE_ATTACKERS, DataFlowDiagramPatternPackage.ATTACKER__COMPONENT_TARGET);
		}
		return possibleAttackers;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<ContainedAsset> getContainedAssets() {
		if (containedAssets == null) {
			containedAssets = new EObjectContainmentEList<ContainedAsset>(ContainedAsset.class, this, DataFlowDiagramPatternPackage.COMPONENT__CONTAINED_ASSETS);
		}
		return containedAssets;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case DataFlowDiagramPatternPackage.COMPONENT__CONTAINED_DATA_FLOWS:
				return ((InternalEList<InternalEObject>)(InternalEList<?>)getContainedDataFlows()).basicAdd(otherEnd, msgs);
			case DataFlowDiagramPatternPackage.COMPONENT__CONTAINED_BY_PRIVILEGE_BOUNDARY:
				return ((InternalEList<InternalEObject>)(InternalEList<?>)getContainedByPrivilegeBoundary()).basicAdd(otherEnd, msgs);
			case DataFlowDiagramPatternPackage.COMPONENT__POSSIBLE_ATTACKERS:
				return ((InternalEList<InternalEObject>)(InternalEList<?>)getPossibleAttackers()).basicAdd(otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case DataFlowDiagramPatternPackage.COMPONENT__CONTAINED_DATA_FLOWS:
				return ((InternalEList<?>)getContainedDataFlows()).basicRemove(otherEnd, msgs);
			case DataFlowDiagramPatternPackage.COMPONENT__CONTAINED_BY_PRIVILEGE_BOUNDARY:
				return ((InternalEList<?>)getContainedByPrivilegeBoundary()).basicRemove(otherEnd, msgs);
			case DataFlowDiagramPatternPackage.COMPONENT__CONTAINED_VULNERABILITIES:
				return ((InternalEList<?>)getContainedVulnerabilities()).basicRemove(otherEnd, msgs);
			case DataFlowDiagramPatternPackage.COMPONENT__POSSIBLE_ATTACKERS:
				return ((InternalEList<?>)getPossibleAttackers()).basicRemove(otherEnd, msgs);
			case DataFlowDiagramPatternPackage.COMPONENT__CONTAINED_ASSETS:
				return ((InternalEList<?>)getContainedAssets()).basicRemove(otherEnd, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case DataFlowDiagramPatternPackage.COMPONENT__NAME:
				return getName();
			case DataFlowDiagramPatternPackage.COMPONENT__CONTAINED_DATA_FLOWS:
				return getContainedDataFlows();
			case DataFlowDiagramPatternPackage.COMPONENT__IS_ASSET:
				return isIsAsset();
			case DataFlowDiagramPatternPackage.COMPONENT__EXTERNAL_DEPENDENCY:
				return getExternalDependency();
			case DataFlowDiagramPatternPackage.COMPONENT__SECURITY_ASSUMPTIONS:
				return getSecurityAssumptions();
			case DataFlowDiagramPatternPackage.COMPONENT__SECURITY_NOTES:
				return getSecurityNotes();
			case DataFlowDiagramPatternPackage.COMPONENT__ELICITATION_REASONING:
				return getElicitationReasoning();
			case DataFlowDiagramPatternPackage.COMPONENT__CONTAINED_BY_PRIVILEGE_BOUNDARY:
				return getContainedByPrivilegeBoundary();
			case DataFlowDiagramPatternPackage.COMPONENT__CONTAINED_VULNERABILITIES:
				return getContainedVulnerabilities();
			case DataFlowDiagramPatternPackage.COMPONENT__POSSIBLE_ATTACKERS:
				return getPossibleAttackers();
			case DataFlowDiagramPatternPackage.COMPONENT__CONTAINED_ASSETS:
				return getContainedAssets();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case DataFlowDiagramPatternPackage.COMPONENT__NAME:
				setName((String)newValue);
				return;
			case DataFlowDiagramPatternPackage.COMPONENT__CONTAINED_DATA_FLOWS:
				getContainedDataFlows().clear();
				getContainedDataFlows().addAll((Collection<? extends DataFlow>)newValue);
				return;
			case DataFlowDiagramPatternPackage.COMPONENT__IS_ASSET:
				setIsAsset((Boolean)newValue);
				return;
			case DataFlowDiagramPatternPackage.COMPONENT__EXTERNAL_DEPENDENCY:
				setExternalDependency((String)newValue);
				return;
			case DataFlowDiagramPatternPackage.COMPONENT__SECURITY_ASSUMPTIONS:
				setSecurityAssumptions((String)newValue);
				return;
			case DataFlowDiagramPatternPackage.COMPONENT__SECURITY_NOTES:
				setSecurityNotes((String)newValue);
				return;
			case DataFlowDiagramPatternPackage.COMPONENT__ELICITATION_REASONING:
				setElicitationReasoning((String)newValue);
				return;
			case DataFlowDiagramPatternPackage.COMPONENT__CONTAINED_BY_PRIVILEGE_BOUNDARY:
				getContainedByPrivilegeBoundary().clear();
				getContainedByPrivilegeBoundary().addAll((Collection<? extends PrivilegeBoundary>)newValue);
				return;
			case DataFlowDiagramPatternPackage.COMPONENT__CONTAINED_VULNERABILITIES:
				getContainedVulnerabilities().clear();
				getContainedVulnerabilities().addAll((Collection<? extends Vulnerability>)newValue);
				return;
			case DataFlowDiagramPatternPackage.COMPONENT__POSSIBLE_ATTACKERS:
				getPossibleAttackers().clear();
				getPossibleAttackers().addAll((Collection<? extends Attacker>)newValue);
				return;
			case DataFlowDiagramPatternPackage.COMPONENT__CONTAINED_ASSETS:
				getContainedAssets().clear();
				getContainedAssets().addAll((Collection<? extends ContainedAsset>)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case DataFlowDiagramPatternPackage.COMPONENT__NAME:
				setName(NAME_EDEFAULT);
				return;
			case DataFlowDiagramPatternPackage.COMPONENT__CONTAINED_DATA_FLOWS:
				getContainedDataFlows().clear();
				return;
			case DataFlowDiagramPatternPackage.COMPONENT__IS_ASSET:
				setIsAsset(IS_ASSET_EDEFAULT);
				return;
			case DataFlowDiagramPatternPackage.COMPONENT__EXTERNAL_DEPENDENCY:
				setExternalDependency(EXTERNAL_DEPENDENCY_EDEFAULT);
				return;
			case DataFlowDiagramPatternPackage.COMPONENT__SECURITY_ASSUMPTIONS:
				setSecurityAssumptions(SECURITY_ASSUMPTIONS_EDEFAULT);
				return;
			case DataFlowDiagramPatternPackage.COMPONENT__SECURITY_NOTES:
				setSecurityNotes(SECURITY_NOTES_EDEFAULT);
				return;
			case DataFlowDiagramPatternPackage.COMPONENT__ELICITATION_REASONING:
				setElicitationReasoning(ELICITATION_REASONING_EDEFAULT);
				return;
			case DataFlowDiagramPatternPackage.COMPONENT__CONTAINED_BY_PRIVILEGE_BOUNDARY:
				getContainedByPrivilegeBoundary().clear();
				return;
			case DataFlowDiagramPatternPackage.COMPONENT__CONTAINED_VULNERABILITIES:
				getContainedVulnerabilities().clear();
				return;
			case DataFlowDiagramPatternPackage.COMPONENT__POSSIBLE_ATTACKERS:
				getPossibleAttackers().clear();
				return;
			case DataFlowDiagramPatternPackage.COMPONENT__CONTAINED_ASSETS:
				getContainedAssets().clear();
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case DataFlowDiagramPatternPackage.COMPONENT__NAME:
				return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
			case DataFlowDiagramPatternPackage.COMPONENT__CONTAINED_DATA_FLOWS:
				return containedDataFlows != null && !containedDataFlows.isEmpty();
			case DataFlowDiagramPatternPackage.COMPONENT__IS_ASSET:
				return isAsset != IS_ASSET_EDEFAULT;
			case DataFlowDiagramPatternPackage.COMPONENT__EXTERNAL_DEPENDENCY:
				return EXTERNAL_DEPENDENCY_EDEFAULT == null ? externalDependency != null : !EXTERNAL_DEPENDENCY_EDEFAULT.equals(externalDependency);
			case DataFlowDiagramPatternPackage.COMPONENT__SECURITY_ASSUMPTIONS:
				return SECURITY_ASSUMPTIONS_EDEFAULT == null ? securityAssumptions != null : !SECURITY_ASSUMPTIONS_EDEFAULT.equals(securityAssumptions);
			case DataFlowDiagramPatternPackage.COMPONENT__SECURITY_NOTES:
				return SECURITY_NOTES_EDEFAULT == null ? securityNotes != null : !SECURITY_NOTES_EDEFAULT.equals(securityNotes);
			case DataFlowDiagramPatternPackage.COMPONENT__ELICITATION_REASONING:
				return ELICITATION_REASONING_EDEFAULT == null ? elicitationReasoning != null : !ELICITATION_REASONING_EDEFAULT.equals(elicitationReasoning);
			case DataFlowDiagramPatternPackage.COMPONENT__CONTAINED_BY_PRIVILEGE_BOUNDARY:
				return containedByPrivilegeBoundary != null && !containedByPrivilegeBoundary.isEmpty();
			case DataFlowDiagramPatternPackage.COMPONENT__CONTAINED_VULNERABILITIES:
				return containedVulnerabilities != null && !containedVulnerabilities.isEmpty();
			case DataFlowDiagramPatternPackage.COMPONENT__POSSIBLE_ATTACKERS:
				return possibleAttackers != null && !possibleAttackers.isEmpty();
			case DataFlowDiagramPatternPackage.COMPONENT__CONTAINED_ASSETS:
				return containedAssets != null && !containedAssets.isEmpty();
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (name: ");
		result.append(name);
		result.append(", isAsset: ");
		result.append(isAsset);
		result.append(", externalDependency: ");
		result.append(externalDependency);
		result.append(", securityAssumptions: ");
		result.append(securityAssumptions);
		result.append(", securityNotes: ");
		result.append(securityNotes);
		result.append(", elicitationReasoning: ");
		result.append(elicitationReasoning);
		result.append(')');
		return result.toString();
	}

} //ComponentImpl
