/**
 */
package de.uni.due.swe.dataFlowDiagramPattern.impl;

import de.uni.due.swe.dataFlowDiagramPattern.Attacker;
import de.uni.due.swe.dataFlowDiagramPattern.AttackerType;
import de.uni.due.swe.dataFlowDiagramPattern.ComplexProcess;
import de.uni.due.swe.dataFlowDiagramPattern.ContainedAsset;
import de.uni.due.swe.dataFlowDiagramPattern.DataFlow;
import de.uni.due.swe.dataFlowDiagramPattern.DataFlowDiagram;
import de.uni.due.swe.dataFlowDiagramPattern.DataFlowDiagramPatternFactory;
import de.uni.due.swe.dataFlowDiagramPattern.DataFlowDiagramPatternPackage;
import de.uni.due.swe.dataFlowDiagramPattern.DataStore;
import de.uni.due.swe.dataFlowDiagramPattern.ExternalEntity;
import de.uni.due.swe.dataFlowDiagramPattern.PrivilegeBoundary;
import de.uni.due.swe.dataFlowDiagramPattern.STRIDEThreats;
import de.uni.due.swe.dataFlowDiagramPattern.Vulnerability;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EDataType;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;

import org.eclipse.emf.ecore.impl.EFactoryImpl;

import org.eclipse.emf.ecore.plugin.EcorePlugin;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Factory</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class DataFlowDiagramPatternFactoryImpl extends EFactoryImpl implements DataFlowDiagramPatternFactory {
	/**
	 * Creates the default factory implementation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static DataFlowDiagramPatternFactory init() {
		try {
			DataFlowDiagramPatternFactory theDataFlowDiagramPatternFactory = (DataFlowDiagramPatternFactory)EPackage.Registry.INSTANCE.getEFactory(DataFlowDiagramPatternPackage.eNS_URI);
			if (theDataFlowDiagramPatternFactory != null) {
				return theDataFlowDiagramPatternFactory;
			}
		}
		catch (Exception exception) {
			EcorePlugin.INSTANCE.log(exception);
		}
		return new DataFlowDiagramPatternFactoryImpl();
	}

	/**
	 * Creates an instance of the factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public DataFlowDiagramPatternFactoryImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EObject create(EClass eClass) {
		switch (eClass.getClassifierID()) {
			case DataFlowDiagramPatternPackage.DATA_STORE: return createDataStore();
			case DataFlowDiagramPatternPackage.COMPLEX_PROCESS: return createComplexProcess();
			case DataFlowDiagramPatternPackage.EXTERNAL_ENTITY: return createExternalEntity();
			case DataFlowDiagramPatternPackage.DATA_FLOW: return createDataFlow();
			case DataFlowDiagramPatternPackage.PROCESS: return createProcess();
			case DataFlowDiagramPatternPackage.DATA_FLOW_DIAGRAM: return createDataFlowDiagram();
			case DataFlowDiagramPatternPackage.PRIVILEGE_BOUNDARY: return createPrivilegeBoundary();
			case DataFlowDiagramPatternPackage.CONTAINED_ASSET: return createContainedAsset();
			case DataFlowDiagramPatternPackage.VULNERABILITY: return createVulnerability();
			case DataFlowDiagramPatternPackage.ATTACKER: return createAttacker();
			default:
				throw new IllegalArgumentException("The class '" + eClass.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object createFromString(EDataType eDataType, String initialValue) {
		switch (eDataType.getClassifierID()) {
			case DataFlowDiagramPatternPackage.STRIDE_THREATS:
				return createSTRIDEThreatsFromString(eDataType, initialValue);
			case DataFlowDiagramPatternPackage.ATTACKER_TYPE:
				return createAttackerTypeFromString(eDataType, initialValue);
			default:
				throw new IllegalArgumentException("The datatype '" + eDataType.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String convertToString(EDataType eDataType, Object instanceValue) {
		switch (eDataType.getClassifierID()) {
			case DataFlowDiagramPatternPackage.STRIDE_THREATS:
				return convertSTRIDEThreatsToString(eDataType, instanceValue);
			case DataFlowDiagramPatternPackage.ATTACKER_TYPE:
				return convertAttackerTypeToString(eDataType, instanceValue);
			default:
				throw new IllegalArgumentException("The datatype '" + eDataType.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public DataStore createDataStore() {
		DataStoreImpl dataStore = new DataStoreImpl();
		return dataStore;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ComplexProcess createComplexProcess() {
		ComplexProcessImpl complexProcess = new ComplexProcessImpl();
		return complexProcess;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ExternalEntity createExternalEntity() {
		ExternalEntityImpl externalEntity = new ExternalEntityImpl();
		return externalEntity;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public DataFlow createDataFlow() {
		DataFlowImpl dataFlow = new DataFlowImpl();
		return dataFlow;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public de.uni.due.swe.dataFlowDiagramPattern.Process createProcess() {
		ProcessImpl process = new ProcessImpl();
		return process;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public DataFlowDiagram createDataFlowDiagram() {
		DataFlowDiagramImpl dataFlowDiagram = new DataFlowDiagramImpl();
		return dataFlowDiagram;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public PrivilegeBoundary createPrivilegeBoundary() {
		PrivilegeBoundaryImpl privilegeBoundary = new PrivilegeBoundaryImpl();
		return privilegeBoundary;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ContainedAsset createContainedAsset() {
		ContainedAssetImpl containedAsset = new ContainedAssetImpl();
		return containedAsset;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Vulnerability createVulnerability() {
		VulnerabilityImpl vulnerability = new VulnerabilityImpl();
		return vulnerability;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Attacker createAttacker() {
		AttackerImpl attacker = new AttackerImpl();
		return attacker;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public STRIDEThreats createSTRIDEThreatsFromString(EDataType eDataType, String initialValue) {
		STRIDEThreats result = STRIDEThreats.get(initialValue);
		if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
		return result;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String convertSTRIDEThreatsToString(EDataType eDataType, Object instanceValue) {
		return instanceValue == null ? null : instanceValue.toString();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public AttackerType createAttackerTypeFromString(EDataType eDataType, String initialValue) {
		AttackerType result = AttackerType.get(initialValue);
		if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
		return result;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String convertAttackerTypeToString(EDataType eDataType, Object instanceValue) {
		return instanceValue == null ? null : instanceValue.toString();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public DataFlowDiagramPatternPackage getDataFlowDiagramPatternPackage() {
		return (DataFlowDiagramPatternPackage)getEPackage();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @deprecated
	 * @generated
	 */
	@Deprecated
	public static DataFlowDiagramPatternPackage getPackage() {
		return DataFlowDiagramPatternPackage.eINSTANCE;
	}

} //DataFlowDiagramPatternFactoryImpl
