/**
 */
package de.uni.due.swe.dataFlowDiagramPattern.util;

import de.uni.due.swe.dataFlowDiagramPattern.Attacker;
import de.uni.due.swe.dataFlowDiagramPattern.ComplexProcess;
import de.uni.due.swe.dataFlowDiagramPattern.Component;
import de.uni.due.swe.dataFlowDiagramPattern.ContainedAsset;
import de.uni.due.swe.dataFlowDiagramPattern.DataFlow;
import de.uni.due.swe.dataFlowDiagramPattern.DataFlowDiagram;
import de.uni.due.swe.dataFlowDiagramPattern.DataFlowDiagramPatternPackage;
import de.uni.due.swe.dataFlowDiagramPattern.DataStore;
import de.uni.due.swe.dataFlowDiagramPattern.ExternalEntity;
import de.uni.due.swe.dataFlowDiagramPattern.PrivilegeBoundary;
import de.uni.due.swe.dataFlowDiagramPattern.Vulnerability;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notifier;

import org.eclipse.emf.common.notify.impl.AdapterFactoryImpl;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * The <b>Adapter Factory</b> for the model.
 * It provides an adapter <code>createXXX</code> method for each class of the model.
 * <!-- end-user-doc -->
 * @see de.uni.due.swe.dataFlowDiagramPattern.DataFlowDiagramPatternPackage
 * @generated
 */
public class DataFlowDiagramPatternAdapterFactory extends AdapterFactoryImpl {
	/**
	 * The cached model package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected static DataFlowDiagramPatternPackage modelPackage;

	/**
	 * Creates an instance of the adapter factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public DataFlowDiagramPatternAdapterFactory() {
		if (modelPackage == null) {
			modelPackage = DataFlowDiagramPatternPackage.eINSTANCE;
		}
	}

	/**
	 * Returns whether this factory is applicable for the type of the object.
	 * <!-- begin-user-doc -->
	 * This implementation returns <code>true</code> if the object is either the model's package or is an instance object of the model.
	 * <!-- end-user-doc -->
	 * @return whether this factory is applicable for the type of the object.
	 * @generated
	 */
	@Override
	public boolean isFactoryForType(Object object) {
		if (object == modelPackage) {
			return true;
		}
		if (object instanceof EObject) {
			return ((EObject)object).eClass().getEPackage() == modelPackage;
		}
		return false;
	}

	/**
	 * The switch that delegates to the <code>createXXX</code> methods.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected DataFlowDiagramPatternSwitch<Adapter> modelSwitch =
		new DataFlowDiagramPatternSwitch<Adapter>() {
			@Override
			public Adapter caseDataStore(DataStore object) {
				return createDataStoreAdapter();
			}
			@Override
			public Adapter caseComplexProcess(ComplexProcess object) {
				return createComplexProcessAdapter();
			}
			@Override
			public Adapter caseExternalEntity(ExternalEntity object) {
				return createExternalEntityAdapter();
			}
			@Override
			public Adapter caseDataFlow(DataFlow object) {
				return createDataFlowAdapter();
			}
			@Override
			public Adapter caseProcess(de.uni.due.swe.dataFlowDiagramPattern.Process object) {
				return createProcessAdapter();
			}
			@Override
			public Adapter caseDataFlowDiagram(DataFlowDiagram object) {
				return createDataFlowDiagramAdapter();
			}
			@Override
			public Adapter caseComponent(Component object) {
				return createComponentAdapter();
			}
			@Override
			public Adapter casePrivilegeBoundary(PrivilegeBoundary object) {
				return createPrivilegeBoundaryAdapter();
			}
			@Override
			public Adapter caseContainedAsset(ContainedAsset object) {
				return createContainedAssetAdapter();
			}
			@Override
			public Adapter caseVulnerability(Vulnerability object) {
				return createVulnerabilityAdapter();
			}
			@Override
			public Adapter caseAttacker(Attacker object) {
				return createAttackerAdapter();
			}
			@Override
			public Adapter defaultCase(EObject object) {
				return createEObjectAdapter();
			}
		};

	/**
	 * Creates an adapter for the <code>target</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param target the object to adapt.
	 * @return the adapter for the <code>target</code>.
	 * @generated
	 */
	@Override
	public Adapter createAdapter(Notifier target) {
		return modelSwitch.doSwitch((EObject)target);
	}


	/**
	 * Creates a new adapter for an object of class '{@link de.uni.due.swe.dataFlowDiagramPattern.DataStore <em>Data Store</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see de.uni.due.swe.dataFlowDiagramPattern.DataStore
	 * @generated
	 */
	public Adapter createDataStoreAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link de.uni.due.swe.dataFlowDiagramPattern.ComplexProcess <em>Complex Process</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see de.uni.due.swe.dataFlowDiagramPattern.ComplexProcess
	 * @generated
	 */
	public Adapter createComplexProcessAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link de.uni.due.swe.dataFlowDiagramPattern.ExternalEntity <em>External Entity</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see de.uni.due.swe.dataFlowDiagramPattern.ExternalEntity
	 * @generated
	 */
	public Adapter createExternalEntityAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link de.uni.due.swe.dataFlowDiagramPattern.DataFlow <em>Data Flow</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see de.uni.due.swe.dataFlowDiagramPattern.DataFlow
	 * @generated
	 */
	public Adapter createDataFlowAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link de.uni.due.swe.dataFlowDiagramPattern.Process <em>Process</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see de.uni.due.swe.dataFlowDiagramPattern.Process
	 * @generated
	 */
	public Adapter createProcessAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link de.uni.due.swe.dataFlowDiagramPattern.DataFlowDiagram <em>Data Flow Diagram</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see de.uni.due.swe.dataFlowDiagramPattern.DataFlowDiagram
	 * @generated
	 */
	public Adapter createDataFlowDiagramAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link de.uni.due.swe.dataFlowDiagramPattern.Component <em>Component</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see de.uni.due.swe.dataFlowDiagramPattern.Component
	 * @generated
	 */
	public Adapter createComponentAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link de.uni.due.swe.dataFlowDiagramPattern.PrivilegeBoundary <em>Privilege Boundary</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see de.uni.due.swe.dataFlowDiagramPattern.PrivilegeBoundary
	 * @generated
	 */
	public Adapter createPrivilegeBoundaryAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link de.uni.due.swe.dataFlowDiagramPattern.ContainedAsset <em>Contained Asset</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see de.uni.due.swe.dataFlowDiagramPattern.ContainedAsset
	 * @generated
	 */
	public Adapter createContainedAssetAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link de.uni.due.swe.dataFlowDiagramPattern.Vulnerability <em>Vulnerability</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see de.uni.due.swe.dataFlowDiagramPattern.Vulnerability
	 * @generated
	 */
	public Adapter createVulnerabilityAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link de.uni.due.swe.dataFlowDiagramPattern.Attacker <em>Attacker</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see de.uni.due.swe.dataFlowDiagramPattern.Attacker
	 * @generated
	 */
	public Adapter createAttackerAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for the default case.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @generated
	 */
	public Adapter createEObjectAdapter() {
		return null;
	}

} //DataFlowDiagramPatternAdapterFactory
